## libvbz-hdf-plugin 1.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11.0)

execute_process(
  COMMAND git describe --tags
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  OUTPUT_VARIABLE GIT_VERSION
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

string(REGEX MATCH "v?([0-9.]+)-?.*" _dummy "${GIT_VERSION}")
set(GIT_VERSION "${CMAKE_MATCH_1}")

message(STATUS "Building version ${GIT_VERSION}")
project(hdf_plugins
    VERSION ${GIT_VERSION}
    LANGUAGES CXX C
)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

include(ExternalProject)
include(GenerateExportHeader)
# If we're including hdf_plugins as a subdir then we might not be able
# to override BUILD_TESTING from CTest's default ON value.
if (NOT DEFINED BUILD_TESTING OR BUILD_TESTING)
    include(CTest)
endif()

if (NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
    message(STATUS "No CMAKE_BUILD_TYPE set - defaulting to Debug")
    # Default to Debug build
    get_property(_bt_docstring
        CACHE CMAKE_BUILD_TYPE
        PROPERTY HELPSTRING)
    set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "${_bt_docstring}" FORCE)
endif()

set(HDF_PLUGIN_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

if (NOT DEFINED VBZ_BUILD_ARCHIVE)
    option(VBZ_BUILD_ARCHIVE "Build vbz release as an single archive" OFF)
endif()

if (NOT DEFINED ENABLE_PYTHON)
    option(ENABLE_PYTHON "Build python wheel" ON)
endif()

if (NOT DEFINED ENABLE_PACKAGING)
    option(ENABLE_PACKAGING "Enable packaging support" ON)
endif()

if (NOT DEFINED ENABLE_PERF_TESTING)
    option(ENABLE_PERF_TESTING "Enable performance tests" ON)
endif()

if (NOT DEFINED ENABLE_CONAN)
    option(ENABLE_CONAN "Enable conan for dependency installation" ON)
endif()

if (NOT DEFINED STANDARD_LIB_INSTALL)
    set(STD_LIB_INSTALL_DEFAULT OFF)
    if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_DIR)
        set(STD_LIB_INSTALL_DEFAULT ON)
    endif()
    option(STANDARD_LIB_INSTALL
        "Install library to standard lib / bin paths"
        ${STD_LIB_INSTALL_DEFAULT}
        )
endif()

if (NOT VBZ_BUILD_ARCHIVE)
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
endif()

if (ENABLE_CONAN)
    #
    # Dependencies: Conan
    #

    if (CONAN_EXPORTED)
        # we're being run by conan
        include("${CMAKE_BINARY_DIR}/conanbuildinfo.cmake")
    else()
        include(conan)

        set(_requirements
            "zstd/1.3.4@nanopore/stable")
        set(_generators
            cmake
            json)
        set(_imports
            "bin, *.dll -> ../bin"
            "lib, *.dylib* -> ../bin")
        set(_extra_args)

        if (ENABLE_PERF_TESTING)
            list(APPEND _requirements
                "google-benchmark/1.5@nanopore/stable"
                )
        endif()
        if (CMAKE_BUILD_TYPE)
            set(_build_type_DEBUG Debug)
            set(_build_type_RELEASE Release)
            set(_build_type_RELWITHDEBINFO Release)
            set(_build_type_MINSIZEREL Release)
            string(TOUPPER "${CMAKE_BUILD_TYPE}" _build_type)
            if(DEFINED _build_type_${_build_type})
                list(APPEND _extra_args BUILD_TYPE "${_build_type_${_build_type}}")
            endif()
        endif()
        if (CONAN_EXTRA_SETTINGS)
            list(APPEND _extra_args
                SETTINGS
                ${CONAN_EXTRA_SETTINGS}
                )
        endif()

        conan_cmake_run(
            GENERATORS ${_generators}
            REQUIRES ${_requirements}
            IMPORTS ${_imports}
            ${_extra_args})
    endif()
    conan_check_compiler()
    conan_define_targets()
    conan_set_find_paths()
endif()

if (ENABLE_PACKAGING)
    include(packaging/hdf_plugin_packaging.cmake)
endif()

include_directories("${CMAKE_CURRENT_SOURCE_DIR}/third_party")

find_package(HDF5 1.8.16)
find_package(zstd 1.3.1 REQUIRED)
find_package(Sanitizers)

get_filename_component(STREAMVBYTE_SOURCE_DIR
    third_party/streamvbyte
    ABSOLUTE
)
set(STREAMVBYTE_INSTALL_DIR "${CMAKE_BINARY_DIR}/streamvbyte_lib/")
set(STREAMVBYTE_PREFIX ${CMAKE_BINARY_DIR}/streamvbyte)
set(STREAMVBYTE_STATIC_LIB_NAME ${CMAKE_STATIC_LIBRARY_PREFIX}streamvbyte_static${CMAKE_STATIC_LIBRARY_SUFFIX})
set(STREAMVBYTE_STATIC_LIB_SUBDIR ".")
get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if (is_multi_config)
    set(STREAMVBYTE_STATIC_LIB_SUBDIR "$<CONFIG>")
endif()
ExternalProject_Add(
    streamvbyte
    SOURCE_DIR ${STREAMVBYTE_SOURCE_DIR}
    UPDATE_DISCONNECTED TRUE
    PREFIX ${STREAMVBYTE_PREFIX}
    CMAKE_ARGS -DCMAKE_INSTALL_PREFIX=${STREAMVBYTE_INSTALL_DIR} -DSTREAMVBYTE_DISABLE_NATIVE=ON -DSTD_FLAGS="-std=c99"
    # We need to tell CMake about libraries we will link to, otherwise some generators (eg: Ninja)
    # complain about how knowing how to build libstreamvbyte_static.a, for example.
    # Ideally, we'd set a hypothetical INSTALL_BYPRODUCTS, and link to the installed file, but that
    # doesn't seem to be an option.
    BUILD_BYPRODUCTS "<BINARY_DIR>/${STREAMVBYTE_STATIC_LIB_NAME}"
)
ExternalProject_Get_Property(streamvbyte BINARY_DIR)
set(STREAMVBYTE_STATIC_LIB "${BINARY_DIR}/${STREAMVBYTE_STATIC_LIB_SUBDIR}/${STREAMVBYTE_STATIC_LIB_NAME}")


########################################################################
#
# Warnings
#
########################################################################

if (MSVC)
    add_compile_options(
        # Level 3 warnings, as errors
        /W3 /WX

        ##
        ## Disable warnings:
        ##

        # C4251: A base class or structure must be declared with the __declspec(dllexport) keyword
        #        for a function in a derived class to be exported.
        #
        # Happens when using STL types as members of a class tagged with WHATEVER_EXPORT. Since we
        # don't care about our DLLs maintaining compatibility with other versions of the CRT
        # (Microsoft's C Runtime Library), this is just noise.
        /wd4251

        # C4275: An exported class was derived from a class that was not exported.
        #
        # Very similar to C4251, but for inheritance rather than members. Again, just noise for us.
        /wd4275

        # C4373: '%$S': virtual function overrides '%$pS', previous versions of the compiler did not
        #        override when parameters only differed by const/volatile qualifiers
        #
        # The current behaviour (virtuals are overridden when their arguments differ only in
        # constness) is what you'd expect - the warning only exists because VS 2008 and earlier had
        # *different* behaviour. Since we never used VS 2008, this warning isn't useful to us.
        /wd4373

        ##
        ## Enable additional warnings:
        ##

        # C5038: data member 'member1' will be initialized after data member 'member2'
        #
        # Enable warning about incorrect order of initialisation in classes.
        # Matches clang warnings which are enabled on the build server.
        /w35038
        )
    set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS
        # MSVC's standard library warns about a lot of "insecure" code by default (eg: unchecked
        # iterators). However, the recommended replacements are not cross-platform, so aren't really
        # an option for us.
        _SCL_SECURE_NO_WARNINGS
        )
elseif (CMAKE_COMPILER_IS_GNUCXX)
    add_compile_options(
        # "All" warnings as errors
        -Wall -Wextra -Werror

        # Unused parameters are too common (and unimportant) to warn about
        -Wno-unused-parameter
        # Missing field init warning is too general to be useful in C++ code
        -Wno-missing-field-initializers
        # boost::optional triggers this on release builds
        -Wno-maybe-uninitialized
        )
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang") # AppleClang and Clang
    add_compile_options(
        # "All" warnings as errors
        -Wall -Werror
        )
endif()

include(SigningUtils)

if (ENABLE_PYTHON)
    add_subdirectory(python)
endif()
add_subdirectory(vbz)
add_subdirectory(vbz_plugin)

=== vbz/CMakeLists.txt ===

add_library(vbz STATIC
    v0/vbz_streamvbyte.h
    v0/vbz_streamvbyte.cpp
    v0/vbz_streamvbyte_impl.h
    v0/vbz_streamvbyte_impl_sse3.h

    v1/vbz_streamvbyte.h
    v1/vbz_streamvbyte.cpp
    v0/vbz_streamvbyte_impl.h

    vbz.h
    vbz.cpp
)
add_sanitizers(vbz)

generate_export_header(vbz EXPORT_FILE_NAME vbz/vbz_export.h)

set_property(TARGET vbz PROPERTY CXX_STANDARD 11)

target_include_directories(vbz
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${CMAKE_CURRENT_BINARY_DIR}
        ${STREAMVBYTE_INSTALL_DIR}/include
)

# This explicit dependency is required to make sure the header files are installed into the right
# location before we try building against them.
add_dependencies(vbz
    streamvbyte
)

if (WIN32 OR APPLE OR "${CMAKE_SYSTEM_PROCESSOR}" MATCHES "x86_64")
    if(NOT MSVC)
        target_compile_options(vbz PRIVATE -mssse3)
    endif()
endif()

target_link_libraries(vbz
    PUBLIC
        ${STREAMVBYTE_STATIC_LIB}
        zstd::zstd
)

if (BUILD_TESTING)
    add_subdirectory(fuzzing)
    add_subdirectory(test)

    if (ENABLE_PERF_TESTING)
        add_subdirectory(perf)
    endif()
endif()

=== vbz_plugin/CMakeLists.txt ===

add_library(vbz_hdf_plugin SHARED
    vbz_plugin_user_utils.h
    vbz_plugin.cpp
    vbz_plugin.h
)
add_sanitizers(vbz_hdf_plugin)

generate_export_header(vbz_hdf_plugin EXPORT_FILE_NAME vbz_plugin/vbz_hdf_plugin_export.h)

set_property(TARGET vbz_hdf_plugin PROPERTY CXX_STANDARD 11)

target_include_directories(
    vbz_hdf_plugin
        PUBLIC
            ${CMAKE_CURRENT_SOURCE_DIR}
            ${CMAKE_CURRENT_BINARY_DIR}
        PRIVATE
            ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/
)

target_link_libraries(vbz_hdf_plugin
    PRIVATE
        vbz
)

if (${CMAKE_CXX_COMPILER_ID} MATCHES "Intel" AND NOT WIN32)
    target_link_libraries(vbz_hdf_plugin
        PRIVATE
        $<$<CXX_COMPILER_ID:Intel>:-static-intel>
        $<$<CXX_COMPILER_ID:Intel>:-mkl=sequential>
        $<$<CXX_COMPILER_ID:Intel>:-wd10237>
        )
endif()

if (ENABLE_CODE_SIGNING)
    hdf_add_signing_command(vbz_hdf_plugin)
endif()

if (WIN32)
    target_compile_definitions(vbz_hdf_plugin
        PRIVATE
            -D_CRT_SECURE_NO_WARNINGS
    )
endif()

if (BUILD_TESTING)
    if (HDF5_FOUND)
        add_subdirectory(hdf_test_utils)

        add_subdirectory(test)

        if (ENABLE_PERF_TESTING)
            add_subdirectory(perf)
        endif()
    else()
        message(STATUS "Not building hdf5 testing as hdf5 not found")
    endif()
endif()

if (NOT VBZ_BUILD_ARCHIVE)
    set(VBZ_PLUGIN_COMPONENT COMPONENT hdf_plugin)
endif()

set(INSTALL_DESTINATION "hdf5/lib/plugin")
if (STANDARD_LIB_INSTALL)
    set(VBZ_PLUGIN_COMPONENT COMPONENT vbz_hdf_plugin)
    set_target_properties(vbz_hdf_plugin
        PROPERTIES
        VERSION ${PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        )
    if(WIN32)
        set(INSTALL_DESTINATION "bin")
    else()
        set(INSTALL_DESTINATION "lib")
    endif()
elseif (VBZ_BUILD_ARCHIVE)
    set(INSTALL_DESTINATION "bin")
endif()

install(
    TARGETS vbz_hdf_plugin
    DESTINATION ${INSTALL_DESTINATION}
    ${VBZ_PLUGIN_COMPONENT}
)

if (APPLE AND VBZ_CODESIGN_IDENTITY AND VBZ_CODESIGN_KEYCHAIN)
    add_custom_command(
        TARGET vbz_hdf_plugin
        POST_BUILD
            COMMAND codesign -s "${VBZ_CODESIGN_IDENTITY}" "${VBZ_CODESIGN_KEYCHAIN}" --force --deep -vvvv $<TARGET_FILE:vbz_hdf_plugin>
            COMMENT "Signing vbz_hdf_plugin with ${VBZ_CODESIGN_IDENTITY}"
    )
endif()

=== vbz/perf/CMakeLists.txt ===
find_package(GoogleBenchmark)

add_executable(vbz_perf_test
    vbz_perf.cpp
)
add_sanitizers(vbz_perf_test)

target_link_libraries(vbz_perf_test
    PRIVATE
        vbz
        google::benchmark
)

set_property(TARGET vbz_perf_test PROPERTY CXX_STANDARD 11)

add_test(
    NAME vbz_perf_test
    COMMAND vbz_perf_test
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

=== vbz/test/CMakeLists.txt ===
add_executable(vbz_test
    streamvbyte_test.cpp
    test_data.h
    test_utils.h
    vbz_test.cpp
    main.cpp
)
add_sanitizers(vbz_test)

set_property(TARGET vbz_test PROPERTY CXX_STANDARD 11)

target_link_libraries(vbz_test
    PUBLIC
        vbz
)

add_test(
    NAME vbz_test
    COMMAND vbz_test
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

=== vbz_plugin/perf/CMakeLists.txt ===
find_package(GoogleBenchmark)

add_executable(vbz_hdf_perf_test
    vbz_hdf_perf.cpp
)
add_sanitizers(vbz_hdf_perf_test)

target_link_libraries(vbz_hdf_perf_test
    PRIVATE
        google::benchmark
        ${HDF5_C_LIBRARIES}
        hdf_test_utils
        vbz_hdf_plugin
)

set_property(TARGET vbz_hdf_perf_test PROPERTY CXX_STANDARD 11)

add_test(
    NAME vbz_hdf_perf_test
    COMMAND vbz_hdf_perf_test
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

=== debian/changelog ===
libvbz-hdf-plugin (1.0.1-2ubuntu1) jammy; urgency=medium

  * debian/patches/update-catch2.patch: import catch2 version 2.13.8 to
    fix build failure with glibc 2.34.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Apr 2022 05:51:59 +0000

libvbz-hdf-plugin (1.0.1-2) unstable; urgency=medium

  * Use DEB_HOST_GNU type for every arch since
    $(DEB_HOST_MULTIARCH) does not match the default
    build directory used by debhelper
  * d/salsa-ci.yml: disable reprotest for now

 -- Nilesh Patra <nilesh@debian.org>  Fri, 20 Aug 2021 00:23:50 +0530

libvbz-hdf-plugin (1.0.1-1) unstable; urgency=medium

  * Initial release (Closes: #988993)

 -- Andreas Tille <tille@debian.org>  Sun, 23 May 2021 10:28:06 +0200

=== debian/control ===
Source: libvbz-hdf-plugin
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>, Nilesh Patra <nilesh@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
#               d-shlibs, # not possible since no static lib
               cmake,
               libzstd-dev,
               libhdf5-dev,
               libstreamvbyte-dev,
               dh-exec
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/libvbz-hdf-plugin
Vcs-Git: https://salsa.debian.org/med-team/libvbz-hdf-plugin.git
Homepage: https://github.com/nanoporetech/vbz_compression/
Rules-Requires-Root: no

Package: libvbz-hdf-plugin0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: VBZ compression plugin for nanopore signal data
 VBZ Compression uses variable byte integer encoding to compress nanopore
 signal data.
 .
 The performance of VBZ is achieved by taking advantage of the properties
 of the raw signal and therefore is most effective when applied to the
 signal dataset. Other datasets you may have in your Fast5 files will not
 be able to take advantage of the default VBZ settings for compression.
 VBZ will be used as the default compression scheme in a future release
 of MinKNOW.
 .
 This package contains the shared object library.

Package: libvbz-hdf-plugin-dev
Architecture: any
Section: libdevel
Depends: libvbz-hdf-plugin0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: VBZ compression plugin for nanopore signal data (devel)
 VBZ Compression uses variable byte integer encoding to compress nanopore
 signal data.
 .
 The performance of VBZ is achieved by taking advantage of the properties
 of the raw signal and therefore is most effective when applied to the
 signal dataset. Other datasets you may have in your Fast5 files will not
 be able to take advantage of the default VBZ settings for compression.
 VBZ will be used as the default compression scheme in a future release
 of MinKNOW.
 .
 This package contains the header files.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release \
				-DENABLE_CONAN=OFF \
				-DENABLE_PERF_TESTING=OFF \
				-DENABLE_PYTHON=OFF

override_dh_install__not_possible_since_no_static_lib:
	dh_install
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --override s/libzstd1-dev/libzstd-dev/ \
		    debian/tmp/usr/lib/*/*.so

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/nanoporetech/vbz_compression//releases .*/archive/.*/v?@ANY_VERSION@\.tar\.gz

## libvbz-hdf-plugin 1.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,6 +17,7 @@
 )
 
 set(CMAKE_POSITION_INDEPENDENT_CODE ON)
+set(CMAKE_CXX_STANDARD 14)
 
 include(ExternalProject)
 include(GenerateExportHeader)
@@ -75,6 +76,8 @@
     set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
 endif()
 
+option(BUILD_SHARED_LIBS "Build shared library for VBZ plugin" ON)
+
 if (ENABLE_CONAN)
     #
     # Dependencies: Conan
@@ -87,7 +90,7 @@
         include(conan)
 
         set(_requirements
-            "zstd/1.3.4@nanopore/stable")
+            "zstd/1.4.8@nanopore/stable")
         set(_generators
             cmake
             json)
@@ -111,10 +114,14 @@
                 list(APPEND _extra_args BUILD_TYPE "${_build_type_${_build_type}}")
             endif()
         endif()
+        if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+            list(APPEND CONAN_EXTRA_SETTINGS "compiler.cppstd=${CMAKE_CXX_STANDARD}")
+        endif()
         if (CONAN_EXTRA_SETTINGS)
             list(APPEND _extra_args
                 SETTINGS
                 ${CONAN_EXTRA_SETTINGS}
+                BUILD missing
                 )
         endif()

=== vbz/CMakeLists.txt ===
--- 
+++ 
@@ -31,7 +31,9 @@
     streamvbyte
 )
 
-if (WIN32 OR APPLE OR "${CMAKE_SYSTEM_PROCESSOR}" MATCHES "x86_64")
+if (WIN32 OR 
+    (APPLE AND NOT "${CMAKE_SYSTEM_PROCESSOR}" MATCHES "arm64") OR
+    "${CMAKE_SYSTEM_PROCESSOR}" MATCHES "x86_64")
     if(NOT MSVC)
         target_compile_options(vbz PRIVATE -mssse3)
     endif()

=== vbz_plugin/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-add_library(vbz_hdf_plugin SHARED
+add_library(vbz_hdf_plugin
     vbz_plugin_user_utils.h
     vbz_plugin.cpp
     vbz_plugin.h
@@ -9,6 +9,16 @@
 generate_export_header(vbz_hdf_plugin EXPORT_FILE_NAME vbz_plugin/vbz_hdf_plugin_export.h)
 
 set_property(TARGET vbz_hdf_plugin PROPERTY CXX_STANDARD 11)
+
+if(WIN32 AND HDF5_USE_STATIC_LIBRARIES)
+    # See vbz_plugin.cpp -- if also building with Python on Windows then the runtime
+    # used is determined by that Python version, so we only support dynamic builds.
+    if(ENABLE_PYTHON)
+        message(FATAL_ERROR "Cannot enable HDF5_USE_STATIC_LIBRARIES as well as ENABLE_PYTHON")
+    else()
+        add_definitions(-DHDF5_USE_STATIC_LIBRARIES)
+    endif()
+endif()
 
 target_include_directories(
     vbz_hdf_plugin

=== python/pyvbz/CMakeLists.txt ===

set(PYVBZ_OUTPUT_PATH "${CMAKE_CURRENT_BINARY_DIR}/pyvbz_cffi.touch")
set(PYVBZ_BUILD_SCRIPT "${CMAKE_CURRENT_SOURCE_DIR}/build_pyvbz.cmake")

if (NOT PYTHON_EXECUTABLE)
    find_package(PythonInterp 3)
endif()

add_custom_command(
    OUTPUT "${PYVBZ_OUTPUT_PATH}"
    COMMAND ${CMAKE_COMMAND}
        ARGS -E env
            PYTHON_EXE="${PYTHON_EXECUTABLE}"
            PYVBZ_DIR="${CMAKE_CURRENT_SOURCE_DIR}"
            VBZ_BUILD_DIR="${CMAKE_BINARY_DIR}"
            VBZ_INCLUDE_PATHS="${CMAKE_SOURCE_DIR}/vbz\;${CMAKE_BINARY_DIR}/vbz/"
            VBZ_LINK_LIBS="$<TARGET_FILE:vbz>\;${STREAMVBYTE_STATIC_LIB}\;${ZSTD_LIBRARY}"
            OUTPUT_FILE="${PYVBZ_OUTPUT_PATH}"
            ${CMAKE_COMMAND}
                -P "${PYVBZ_BUILD_SCRIPT}"
    DEPENDS vbz "${PYVBZ_BUILD_SCRIPT}"
)

set(PYVBZ_ALL)
if (NOT WIN32)
    set(PYVBZ_ALL "ALL")
endif()

add_custom_target(pyvbz "${PYVBZ_ALL}"
    DEPENDS "${PYVBZ_OUTPUT_PATH}")

if (BUILD_TESTING AND NOT WIN32)
    set(PYVBZ_VENV_PATH "${CMAKE_CURRENT_BINARY_DIR}/venv")
    set(PYVBZ_VENV_PYTHON "${PYVBZ_VENV_PATH}/bin/python")
    add_custom_command(
        OUTPUT "${PYVBZ_VENV_PYTHON}"
        COMMAND ${PYTHON_EXECUTABLE} -m venv
            --system-site-packages "${CMAKE_CURRENT_BINARY_DIR}/venv"
        COMMAND "${PYVBZ_VENV_PYTHON}" -m pip install -r
            "${CMAKE_CURRENT_SOURCE_DIR}/requirements.txt"
        COMMAND ${CMAKE_COMMAND} -E env
            VBZ_BUILD_DIR="${CMAKE_BINARY_DIR}"
            VBZ_INCLUDE_PATHS="${CMAKE_SOURCE_DIR}/vbz\;${CMAKE_BINARY_DIR}/vbz/"
            VBZ_LINK_LIBS="$<TARGET_FILE:vbz>\;${STREAMVBYTE_STATIC_LIB}\;${ZSTD_LIBRARY}"
            "${PYVBZ_VENV_PYTHON}" setup.py develop
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/setup.py"
    )
    add_custom_target(pyvbz_venv ALL DEPENDS "${PYVBZ_VENV_PYTHON}")

    add_test(
        NAME pyvbz_test
        COMMAND "${PYVBZ_VENV_PYTHON}" ./tests/unit
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )
endif()

=== python/pyvbz/requirements.txt ===
numpy
cffi

=== vbz/fuzzing/CMakeLists.txt ===

if (SANITIZE_FUZZER)
    message(STATUS "Building vbz fuzz support")

    add_executable(vbz_fuzz_test
        vbz_fuzz.cpp
    )

    target_link_libraries(vbz_fuzz_test
        PUBLIC
            vbz)

    add_sanitize_fuzzer(vbz_fuzz_test)
    add_sanitizers(vbz_fuzz_test)
endif()

=== vbz/test/CMakeLists.txt ===
--- 
+++ 
@@ -9,9 +9,12 @@
 
 set_property(TARGET vbz_test PROPERTY CXX_STANDARD 11)
 
+find_package( Threads )
+
 target_link_libraries(vbz_test
     PUBLIC
         vbz
+    ${CMAKE_THREAD_LIBS_INIT}
 )
 
 add_test(

=== vbz_plugin/hdf_test_utils/CMakeLists.txt ===
add_library(hdf_test_utils STATIC
    hdf_id_helper.cpp
    hdf_id_helper.h
)

set_property(TARGET hdf_test_utils PROPERTY CXX_STANDARD 11)

target_include_directories(hdf_test_utils
    PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${HDF5_C_INCLUDE_DIRS}
)

target_link_libraries(hdf_test_utils
    PRIVATE
        ${HDF5_C_LIBRARIES}
)

=== vbz_plugin/test/CMakeLists.txt ===
add_executable(vbz_hdf_plugin_test
    vbz_hdf_plugin_test.cpp
    main.cpp
)
add_sanitizers(vbz_hdf_plugin_test)

set_property(TARGET vbz_hdf_plugin_test PROPERTY CXX_STANDARD 11)

target_link_libraries(vbz_hdf_plugin_test
    PUBLIC
        vbz_hdf_plugin
        ${HDF5_C_LIBRARIES}
        hdf_test_utils
)

add_test(
    NAME vbz_hdf_plugin_test
    COMMAND vbz_hdf_plugin_test "${CMAKE_SOURCE_DIR}/test_data"
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

=== debian/changelog ===
libvbz-hdf-plugin (1.0.2-3.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:51:00 +0000

libvbz-hdf-plugin (1.0.2-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062695

 -- Graham Inggs <ginggs@debian.org>  Wed, 28 Feb 2024 21:02:18 +0000

libvbz-hdf-plugin (1.0.2-3) unstable; urgency=medium

  * gcc-13.patch: new: fix build failures with gcc 13. (Closes: #1037746)
  * d/rules: build with -Wno-error=dangling-reference.
    This works around a, possibly, false positive warning while building
    the file vbz/vbz.cpp with gcc 13 onwards.

 -- Étienne Mollier <emollier@debian.org>  Sun, 23 Jul 2023 10:52:45 +0200

libvbz-hdf-plugin (1.0.2-2) unstable; urgency=medium

  * Remove symbols file according to
    https://wiki.debian.org/UsingSymbolsFiles#C.2B-.2B-_libraries
  * Add lintian-overrides to express that symbols file was removed
    intentionally
  * Standards-Version: 4.6.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Tue, 07 Feb 2023 09:05:03 +0100

libvbz-hdf-plugin (1.0.2-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * Drop unnecessary dependency on build-essential.
  * Apply multi-arch hints.
    + libvbz-hdf-plugin-dev: Add Multi-Arch: same.
  * Refresh use-packaged-streamvbyte.patch.
  * Refresh fix-install-location.patch.
  * Delete update-catch2.patch: applied upstream.
  * d/rules: enable hardening.
  * Add symbols tracking for libvbz-hdf-plugin0.

 -- Étienne Mollier <emollier@debian.org>  Sun, 03 Jul 2022 14:23:31 +0200

libvbz-hdf-plugin (1.0.1-3) unstable; urgency=medium

  [ Steve Langasek ]
  * Import catch2 version 2.13.8 to fix build failure with glibc 2.34
    Closes: #1009620

  [ Andreas Tille ]
  * Fix watchfile to detect new versions on github
  * Standards-Version: 4.6.0 (routine-update)

 -- Nilesh Patra <nilesh@debian.org>  Thu, 14 Apr 2022 23:58:47 +0530

=== debian/control ===
--- 
+++ 
@@ -1,27 +1,31 @@
 Source: libvbz-hdf-plugin
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Andreas Tille <tille@debian.org>, Nilesh Patra <nilesh@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>,
+           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
-#               d-shlibs, # not possible since no static lib
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                cmake,
                libzstd-dev,
                libhdf5-dev,
                libstreamvbyte-dev,
                dh-exec
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/libvbz-hdf-plugin
 Vcs-Git: https://salsa.debian.org/med-team/libvbz-hdf-plugin.git
 Homepage: https://github.com/nanoporetech/vbz_compression/
 Rules-Requires-Root: no
 
-Package: libvbz-hdf-plugin0
+Package: libvbz-hdf-plugin0t64
+Provides: ${t64:Provides}
+Replaces: libvbz-hdf-plugin0
+Breaks: libvbz-hdf-plugin0 (<< ${source:Version})
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}
+Multi-Arch: same
 Description: VBZ compression plugin for nanopore signal data
  VBZ Compression uses variable byte integer encoding to compress nanopore
  signal data.
@@ -38,9 +42,10 @@
 Package: libvbz-hdf-plugin-dev
 Architecture: any
 Section: libdevel
-Depends: libvbz-hdf-plugin0 (= ${binary:Version}),
+Depends: libvbz-hdf-plugin0t64 (= ${binary:Version}),
          ${shlibs:Depends},
          ${misc:Depends}
+Multi-Arch: same
 Description: VBZ compression plugin for nanopore signal data (devel)
  VBZ Compression uses variable byte integer encoding to compress nanopore
  signal data.

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,11 @@
 
 # DH_VERBOSE := 1
 export LC_ALL=C.UTF-8
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+# Work around against the following warning that cropped up with gcc 13.1.0:
+#       vbz/vbz.cpp:314:17: error: possibly dangling reference to a temporary
+export DEB_CXXFLAGS_MAINT_APPEND = -Wno-error=dangling-reference
 
 include /usr/share/dpkg/default.mk

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/nanoporetech/vbz_compression//releases .*/.*/v?@ANY_VERSION@\.tar\.gz
